function ScatSeis(sc,stat1,stat2,stat3)

%stat1='*.ocd'; %% original coda
%stat2='*.ccd'; %% convolved coda
%stat3='*.stf'; %% source time function

%% read original coda
  fid = fopen([sc stat1],'r');
  for ii=1:8;
    line=fgetl(fid);
  end
  data = fscanf(fid,'%g %e %e %e',[4 inf]); 
  fclose(fid);
  data = data';
  t = data(:,1); ns = data(:,2); ew = data(:,3); ud = data(:,4);

%% read convolved coda
  fid2 = fopen([sc stat2],'r');
  for ii=1:8;
    line=fgetl(fid2);
  end
  data2 = fscanf(fid2,'%g %e %e %e',[4 inf]);  
  fclose(fid2);
  data2 = data2';
  cns = data2(:,2); cew = data2(:,3); cud = data2(:,4);  
  
% computes dt;
  dt=t(5)-t(4);

%% read stf
  fid3 = fopen([sc stat3],'r');
  for ii=1:8;
    line=fgetl(fid3);
  end
  data3 = fscanf(fid2,'%g %e',[2 inf]);  
  fclose(fid2);
  data3 = data3';
  t_stf = data3(:,1); stf = data3(:,2);

% computes stf dt;
  dt_stf=t_stf(5)-t_stf(4);
  
  %% FAS of Original Coda
  [fas_ew,f] = sfft(ew,dt);
  [fas_ns,f] = sfft(ns,dt);
  [fas_ud,f] = sfft(ud,dt);  
  
  %% FAS of Convolved Coda
  [fas_cew,f2] = sfft(cew,dt);
  [fas_cns,f2] = sfft(cns,dt);
  [fas_cud,f2] = sfft(cud,dt); 

  %% FAS of STF
  [fas_stf,f3] = sfft(stf,dt_stf);  

   figure;
   subplot(3,1,1); plot(t,ns); title('Original Coda'); ylabel('Vel (m/s)');
   subplot(3,1,2); plot(t,ew); ylabel('Vel (m/s)');
   subplot(3,1,3); plot(t,ud); ylabel('Vel (m/s)'); xlabel('Time (s)');
%   
   figure;
   subplot(3,1,1); plot(t,cns); title('Convolved Coda'); ylabel('Vel (m/s)');
   subplot(3,1,2); plot(t,cew); ylabel('Vel (m/s)');
   subplot(3,1,3); plot(t,cud); ylabel('Vel (m/s)'); xlabel('Time (s)');
%   
   figure;
   subplot(2,1,1); plot(t_stf,stf); title('Source time function'); xlabel('Time (s)'); ylabel('Slpi-rate (m/s)');
   subplot(2,1,2); loglog(f3,fas_stf); xlabel('Freq (Hz)'); ylabel('Vel (m)');

   figure;
   subplot(3,1,1); loglog(f,fas_ns); title('Original Coda'); ylabel('Vel (m)');
   subplot(3,1,2); loglog(f,fas_ew); ylabel('Vel (m)');
   subplot(3,1,3); loglog(f,fas_ud); xlabel('Freq (Hz)'); ylabel('Vel (m)');

   figure;
   subplot(3,1,1); loglog(f2,fas_cns); title('Convolved Coda'); ylabel('Vel (m)');
   subplot(3,1,2); loglog(f2,fas_cew); ylabel('Vel (m)');
   subplot(3,1,3); loglog(f2,fas_cud); xlabel('Freq (Hz)'); ylabel('Vel (m)');
